Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/symboltable/ProgrammingSymbolTableFactory.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/symboltable/ProgrammingSymbolTableFactory.java	(revision 44205)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/symboltable/ProgrammingSymbolTableFactory.java	(revision 44206)
@@ -12,7 +12,7 @@
     private SymbolTable symbolTable;
     
     public ProgrammingSymbolTableFactory() {
-        super(UtilsSymbolTable.NAME, true);
+        super(ProgrammingSymbolTable.NAME, true);
     }
     
     @Override
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/numeric/DecrFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/numeric/DecrFunction.java	(revision 44205)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/numeric/DecrFunction.java	(revision 44206)
@@ -1,6 +1,7 @@
 package org.gvsig.expressionevaluator.impl.function.numeric;
 
 import org.apache.commons.lang3.Range;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_DECR;
 import org.gvsig.expressionevaluator.Interpreter;
 import org.gvsig.expressionevaluator.MutableSymbolTable;
 import org.gvsig.expressionevaluator.spi.AbstractFunction;
@@ -8,9 +9,9 @@
 public class DecrFunction extends AbstractFunction {
 
     public DecrFunction() {
-        super("Numeric", "DECR",Range.between(1,3),
+        super("Numeric", FUNCTION_DECR,Range.between(1,3),
             "Decrease the value of the indicated identifier and return its value.",
-            "Decr({{identifier_name}})",
+            FUNCTION_DECR+"('CONTADOR#1')",
             new String[]{
                 "identifier name - the identifier used as counter.",
                 "first value - Optional. The value with which the identifier must be initialized in its first use. By default zero",
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/numeric/IncrFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/numeric/IncrFunction.java	(revision 44205)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/numeric/IncrFunction.java	(revision 44206)
@@ -1,6 +1,9 @@
 package org.gvsig.expressionevaluator.impl.function.numeric;
 
 import org.apache.commons.lang3.Range;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_INCR;
+import org.gvsig.expressionevaluator.Function;
 import org.gvsig.expressionevaluator.Interpreter;
 import org.gvsig.expressionevaluator.MutableSymbolTable;
 import org.gvsig.expressionevaluator.spi.AbstractFunction;
@@ -8,9 +11,9 @@
 public class IncrFunction extends AbstractFunction {
 
     public IncrFunction() {
-        super("Numeric", "INCR",Range.between(1,3),
+        super("Numeric", FUNCTION_INCR, Range.between(1,3),
             "Increase the value of the indicated identifier and return its value.",
-            "Incr({{identifier_name}})",
+            FUNCTION_INCR+"('CONTADOR#1')",
             new String[]{
                 "identifier name - the identifier used as counter.",
                 "first value - Optional. The value with which the identifier must be initialized in its first use. By default zero",
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/ExpressionBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/ExpressionBuilder.java	(revision 44205)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/ExpressionBuilder.java	(revision 44206)
@@ -111,6 +111,9 @@
     public static final String FUNCTION_TOLONG = "TOLONG";
     public static final String FUNCTION_TOSTR = "TOSTR";
     
+    public static final String FUNCTION_INCR = "INCR";
+    public static final String FUNCTION_DECR = "DECR";
+    
     public enum GeometrySupportType {
         WKT,
         WKB,